<?php
/* ------------------------------------------------------------------------------------------------------------------
 foto downloader 1.1 beta

 (c) 2006, 2010 Juergen Galupki  http://galupki.de
 keinerlei gewhrleistung fr fehlerfreie Funktion!
 siehe auch http://galupki.de/kontakt/readme-kontakt-lizenz.html

 frei nach einer Idee von Jake Olefsky (photosort) http://www.offsky.com/software/photosort/index.php

nderungen
==========
20100104 1.1 - ergnzt um Panasonic (Lumix DMC-FX500)

Funktion
========
- das Script kopiert alle gefundenen Dateien von "Quelle" nach "Ziel"
- wenn checkonly angekreuzt ist werden keine Daten kopiert, es wird nur die Quelle untersucht (+angezeigt was passieren WRDE)
- die Dateien werden in eine datumsorientierte Verzeichnisstruktur einsortiert, die ggf. neu angelegt wird
- enthalten die Dateien (z.B. *.jpg) ein EXIF-Entstehungsdatum, wird dieses als Zeitstempel verwendet
- fr alle anderen Dateien wird das letzte Modifikationsdatum der Datei benutzt
- die Dateinamen selbst werden gendert zu: jjjjmmtt_hhmmss-oldname.endung
  wenn sie EXIF-daten enthalten (Aufnahmedatum) bzw. aus anderer quelle erkennbar sind und nicht schon derart umbenannt sind
- Verzeichnisstruktur:           ...Ziel/yyyy/mm/...
- Ausnahmen: AVI-/MOV-Dateien werden noch unterhalb des Monats in ein separates Unterverzeichnis (...Ziel/yyyy/mm/film/...) gesteckt, 
  ggf. pano-Dateien ebenso (...Ziel/yyyy/mm/pano/...)
- fr bereits existierende Dateien werden Gre und Datum-letzte-nderung verglichen und Unstimmigkeiten angezeigt
- kennt die (einige) Datei(system)-Besonderheiten von Fujifilm, Canon, Panasonic
------------------------------------------------------------------------------------------------------------------ */




// --- setup --- Vorschlagswerte fr Quelle und Ziel - ggf. anpassen! -----------------------------------------------
$setupdirsource = "g:";
$setupdirtarget = "f:/pic";                     // muss existieren, ggf. einmal anlegen
//$setupdirsource = "f:/temp/QUELLE";
//$setupdirtarget = "f:/temp/ZIEL";      
$setupmodus     = "rekursiv";                   // rekursiv / dir
$setupmovie     = "film";                       // unterverzeichnisname fr AVI-/MOV-Files oder leer
$setuppano      = "pano";                       // unterverzeichnisname fr Panorama-Files oder leer

// --- keine Aenderungen ab hier wenn man sich nicht mit php auskennt -----------------------------------------------



// --- nur ein thumbnail anzeigen und Schluss? ----------------------------------------------------------------------
if ( isset($_REQUEST["thumbnail"]) ) {
   $thumbnail = $_REQUEST["thumbnail"];
   show_thumbnail($thumbnail);
   exit;
}



html_header();
echo "<h2>foto downloader 1.1 beta</h2>\n";

// --- Formularwesen ------------------------------------------------------------------------------------------------

$protfile = basename($_SERVER['PHP_SELF']);
$protfile = substr($protfile,0,strlen($protfile)-4)     // wird immer ins Targetdir geschrieben!
          . "-protokoll.log";
$protswitch = false;


if ( isset($_REQUEST["submit"]) ) {
   $submit = $_REQUEST["submit"];
} elseif ( !isset($workdir) ) {
echo "<p>Klick auf <strong>submit</strong> kopiert alle(!) Dateien von Quelle nach Ziel, ";
echo "ndert dabei aber <br />ggf. die Unterverzeichnisstruktur in eine Datumsorientierte ";
echo "(/Ziel/<strong>jjjj/mm/</strong>datei...). <br />&nbsp;<br />";
echo "Enthalten Dateien Metadaten (EXIF), wird ausserdem das Entstehungsdatum als <br />Dateinameprefix ergnzt";
echo " (.../<strong>jjjjmmtt_hhmmss-</strong>dateiname...) sofern nicht bereits so benannt.</p>";
$_REQUEST["checkonly"] = true;
}
if ( isset($_REQUEST["cameramode"]) OR !isset($_REQUEST["submit"]) ) {
   $cameramode = true;
}  else {
   $cameramode = false;
}
if ( isset($_REQUEST["checkonly"]) ) {
   $checkonly = true;
}  else {
   $checkonly = false;
}
if ( !isset($_REQUEST["dirsource"]) OR $_REQUEST["dirsource"]=="" ) {
   unset($submit);
   $dirsource = $setupdirsource;
}  else {
   $dirsource = stripslashes($_REQUEST["dirsource"]);
}
if ( !isset($_REQUEST["dirtarget"]) OR $_REQUEST["dirtarget"]=="" ) {
   unset($submit);
   $dirtarget = $setupdirtarget;
}  else {
   $dirtarget = stripslashes($_REQUEST["dirtarget"]);
}
if ( !isset($_REQUEST["modus"]) ) {
   $modus = $setupmodus;
   $workdir = $dirsource;
}  elseif ( $_REQUEST["modus"]=="rekursiv" ) {
   $modus = "rekursiv";
}  else {
   $modus = "dir";
   if ( !isset($_REQUEST["workdir"]) ) {
      $workdir = $dirsource;
   }  else {
      $workdir = $_REQUEST["workdir"];
      if ( strtolower(substr($workdir,0,strlen($dirsource)))!=strtolower($dirsource) ) {
         $workdir = $dirsource;
      }
   }
   $workdir = str_replace("//","/",str_replace("\\","/",realpath("$workdir/./")));
   if ( !chdir($workdir) ) {
      echo "chdir($workdir) nicht erfolgreich!";
   }
}



echo "<form action=\"".basename($_SERVER['PHP_SELF'])."\" method=\"post\">\n";
echo "<table border=\"0\" width=\"97%\">\n";
echo "<tr>\n<td valign=\"top\" width=\"50%\">";
echo "<input type=\"text\" size=\"40\" maxlength=\"64\" name=\"dirsource\" value=\"$dirsource\" /> <= Quelle (kopiere von...) ";
echo "z.B. USB-Kamera-Device\n<br />";
echo "<input type=\"text\" size=\"40\" maxlength=\"64\" name=\"dirtarget\" value=\"$dirtarget\" /> <= Ziel (...nach)\n<br />";

echo "<input type=\"radio\" name=\"modus\" value=\"rekursiv\" ";
if ( $modus=="rekursiv" ) {
   echo "checked=\"checked\"";
}
echo "/> <strong>alle</strong> Verzeichnisse bearbeiten &nbsp; ";
echo "<input type=\"radio\" name=\"modus\" value=\"dir\" ";
if ( $modus=="dir" ) {
   echo "checked=\"checked\"";
}
echo "/> In Verzeichnissen selbst navigieren<br />\n";

echo "<input type=\"checkbox\" name=\"cameramode\" value=\"true\" ";
if ( $cameramode ) {
   echo "checked=\"checked\"";
}
echo " /> Kameramodus (Herstellerspezifika bercksichtigen, kein copy von Hilfsdateien...)\n<br />";

echo "<input type=\"checkbox\" name=\"checkonly\" value=\"true\" ";
if ( $checkonly ) {
   echo "checked=\"checked\"";
}
echo " /> nur Check der Quelle, es erfolgt kein copy\n<br />";
echo "</td>\n<td valign=\"top\" width=\"50%\">";

unset($dirs);

if ( $modus=="dir" ) {
   $workdir = str_replace("//","/",str_replace("\\","/",realpath("$workdir/./")));
   if ( substr($workdir,-1,1)=="/" ) {
      $workdir = substr($workdir,0,strlen($workdir)-1);      // korrektur: / hinten entfernen
   }
   if ( strlen($workdir)>strlen($dirsource) ) {
      $xtmp = str_replace("\\","/",realpath("$workdir/../"));
      if ( substr($xtmp,-1,1)!="/" ) {                                          // ergaenze uebergeordnetes Verzeichnis
         $dirs[] = $xtmp;
      }  else {
         $dirs[] = substr($xtmp,0,strlen($xtmp)-1);
      }
   }
   $dirs[] =  $workdir;                                                         // ergaenze Arbeitsverzeichnis

   $handle = opendir($workdir);
   while ($dirname = @readdir($handle)) {
      if ( is_dir("$workdir/$dirname") ) {
         if ( $dirname!= "." AND $dirname!=".." ) {
            $dirs[] = "$workdir/$dirname";                                      // ergaenze Unterverzeichnis
         }
      }
   }
   closedir($handle);

   sort($dirs);
   echo "<br />Aktuelles Verzeichnis: <strong>$workdir</strong><br />\n";
   echo "<select size=\"6\" name=\"workdir\">";
   foreach ($dirs as $tmpdir) {
      echo "<option";
      if ( $tmpdir==$workdir ) {
         echo " selected";
      }
      echo ">$tmpdir</option>";
   }
   echo "</select>\n<br />\n";
} // endif modus dir

echo "<input type=\"submit\" title=\"Benutzung auf eigene Gefahr...\" name=\"submit\" value=\"submit\" /> \n";
echo "</td></tr>\n";
echo "</table>\n";
echo "</form>\n";

if ( !isset($submit) AND !isset($workdir) ) {
   exit;
}


// --- todo ---------------------------------------------------------------------------------------------------------
unset($dir_neu);      // neu angelegte Verzeichnisse sammeln (wird alles am Ende angezeigt)
$uebertragen_mb = 0;  // Datenmenge in MB
$uebertragen_n  = 0;  // Anzahl bertragen
$anzahl         = 0;  // Anzahl gesamt gecheckt
$dcim           = ""; // DCF Design Rule for Camera File System  konformitt


# prepare
set_time_limit(0); //timeout entfernen (meist 30 sek.)


#echo "Quelle: $dirsource &nbsp; ";
#echo "Ziel: $dirtarget\n";


# minimale checks
if ( checkExifversion()==0 ) {
   die("Keine EXIF-Untersttzung auf diesem Webserver, Ende!");
}

if ( !is_dir($dirsource) ) {
   die("Quellverzeichnis $dirsource existiert nicht, Ende!");
}

if ( !is_dir($dirtarget) AND $checkonly==false ) {
   die("Zielverzeichnis $dirtarget existiert nicht, Ende!");
}

if ( !is_writable($dirtarget) AND $checkonly==false ) {
   die("Ins Zielverzeichnis $dirtarget kann nicht geschrieben werden, Ende!");
}

if ( substr($dirtarget,0,strlen($dirsource))==$dirsource AND $modus=="rekursiv" ) {
   die("Zielverzeichnis $dirtarget ist im Quellverzeichnis $dirsource enthalten => Rekursion, Ende!");
}


# transfer files - es wird ernster
echo "<div class=\"small\">\n";
if ( $checkonly ) {
   echo "<h3>Script luft nur im Testmodus, es werden keine Daten kopiert!</h3>";
}
echo "<table border=\"0\" width=\"97%\">\n";
echo "<colgroup><col width=\"33%\"><col width=\"33%\"><col width=\"33%\"></colgroup><tbody>\n";
$tabclass="cbox";

if ( $modus=="dir" ) {
   $dirsource = $workdir;
}
bearbeiteVerzeichnis($dirsource);  // ruft rekursiv weitere Verzeichnisse auf wenn ntig

echo "\n</tbody></table>\n";
echo "</div>\n";

# ende, Statistik
echo "\n<hr />\n";
if ( $checkonly ) {
   echo "<h3>Check:</h3>\n";
   echo "<a href=\"file:///$setupdirtarget/$protfile\">$setupdirtarget/$protfile</a><br />";
} elseif ($protswitch==true) {
   echo "<h3>Copy erfolgreich</h3>\n";
   echo "<a href=\"file:///$setupdirtarget/$protfile\">$setupdirtarget/$protfile</a><br />";
}
echo "$uebertragen_n neue Datei(en) mit insgesamt <br />$uebertragen_mb MB Daten wurden bertragen.<br />";
echo "\n$anzahl Dateien wurden insgesamt berprft.\n&nbsp;";
if ( count($dir_neu)>0 ) {
   echo "\n<br />Folgende Verzeichnisse existierten noch nicht und wurden neu angelegt:<br />\n&nbsp;";
   sort($dir_neu);
   foreach ($dir_neu as $key => $val) {
       echo "\n<br />$val\n";
   }
}
echo "<p class=\"footnote\">(c) Juergen Galupki - <a href=\"http://galupki.de\">http://galupki.de</a></p></body></html>";
exit;



// --- functions ---------------------------------------------------------------------------------------------------



function checkExifversion() {
# koennen exif-daten ermittelt werden?
	$capabilities = get_extension_funcs("exif");
	if(!$capabilities) return 0;
	if(in_array ("exif_read_data",$capabilities)) return 1;
	return 0;
}



function confirmDirectory($path) {
# existiert das verzeichnis bzw. kann es angelegt werden?
 global $dir_neu, $checkonly;

	$success = 1;

	if(!is_dir($path)) {
     if ( $checkonly==false ) {
      		$success = @mkdir($path,0777);
      		if (!$success) {
       			 echo "ERROR: Couldnt create ".$path;
        			exit();
      		}  else {
      		   $dir_neu[] = $path;
      		}
     }  elseif ( !isset($dir_neu) OR !in_array($path, $dir_neu) ) { // checkonly
   		   $dir_neu[] = "$path";
     }
 }
	return $success;
}



function bearbeiteVerzeichnis($actdir) {
# verarbeitet ein ganzes verzeichnis
 global $uebertragen_mb, $uebertragen_n, $anzahl;
 global $dirtarget, $tabclass, $checkonly, $cameramode, $dcim, $setupmovie, $setuppano;
 global $modus;

# lies sequentiell das Verzeichnis aus
 $handle = opendir($actdir);
 while ($file = @readdir($handle)) {
    if ( is_dir("$actdir/$file") ) {
       if ( substr($file,0,1)!= "." AND $modus=="rekursiv" ) {
# ein weiteres (unter-)verzeichnis rekursiv bearbeiten
          bearbeiteVerzeichnis("$actdir/$file");
       }
    }  else {
# es geht um eine datei
       $anzahl++;
       $name_from = "$actdir/$file";
#      dateinamen parsen
       $path_parts = pathinfo($name_from);
       $extension = strtolower($path_parts["extension"]);

#      if ( substr(strtolower($file),-3)=="avi" ) {
#         $setupmovies extra Verzeichnis (ggf. weitere Spezialitaeten hier mit elseifs (...) einfgen...)
#         $subdir = "avi";
#      }  else {
#         jpg / tif / ...
          $subdir = "";
#      } // ende jpg oder other

       $make         = "";
       $org_datetime = "";
       $info_d       = "";


# EXIF-Daten ermitteln

       $exifdata     = @exif_read_data("$actdir/$file","",true,false);
       if ( $exifdata==true ) {
#         exif/metadatenheader erkannt
          $org_filename = $exifdata["FILE"]["FileName"];
          $org_filesize = round($exifdata["FILE"]["FileSize"]/1000000,3); // in MB
          $org_datetime = $exifdata["EXIF"]["DateTimeOriginal"];
#         kamerahersteller
          $make = strtoupper($exifdata["IFD0"]["Make"]);
#		  echo($make);
#         wenn keine echten EXIF-Daten vorhanden sind, nimm das Datei-Erstellungsdatum
          if ( $org_datetime=="" ) {
             $info_d = " ./. EXIF ";
             $org_datetime = date("Y:m:d H:i:s", $exifdata["FILE"]["FileDateTime"]);
          }
       }  else {
#         ueberhaupt keine Metadaten enthalten - wahrscheinlich sowieso keine Bilddatei
          $org_filename = $file;
          $info_d = " ./. META ";
          $org_filesize = round(filesize("$actdir/$file")/1000000,3);
          $org_datetime = date("Y:m:d H:i:s", filemtime("$actdir/$file"));
       }

#      vorletzter versuch
#      kamerahersteller via Pfadname (ziemlich unsicher...)
       if ( $make=="" ) {
          $pos = strpos (strtoupper($actdir), "CANON");
          if ($pos==true ) {
             $make = "CANON";
          }
          $pos = strpos (strtoupper($actdir), "FUJI");
          if ($pos==true ) {
             $make = "FUJIFILM";
          }
          $pos = strpos (strtoupper($actdir), "PANA");
          if ($pos==true ) {
             $make = "PANASONIC";
          }
       }

#      letzter Versuch...
       if ( $make=="" ) {
          $pos = strpos (strtoupper($actdir), "DCIM");   // generischer Standard
          if ( ($extension=="avi" OR $extension=="raf" OR $extension=="wav") AND strtolower(substr($file,0,4))=="dscf" ) {
             $make = "FUJIFILM";
          }  elseif ( $extension=="wav" OR $extension=="avi" ) { // annotation soundfile
             $imagefile = $actdir."/".str_replace("avi","thm",str_replace("wav","jpg",str_replace("snd","img", strtolower($file))));
             $imagefile = strtoupper($imagefile);
             if ( file_exists($imagefile) ) {
                $exifdata = @exif_read_data("$imagefile","",true,false);
                $make = strtoupper($exifdata["IFD0"]["Make"]);
             }
          }  elseif ($pos==true ) {
             $make = "DCIM";
          }
          $info_d = " evaluated ";
       }

#      besonderheiten je kamerahersteller
       $restore_info_d = $info_d;
       $neue_endung    = "";

       if ( $cameramode OR $make!="" ) {
          switch ($make) {
          case "DCIM":
                        $imagefile = str_replace("avi","thm",str_replace("wav","jpg",str_replace("snd","img", strtolower($file))));
                        $exifdata     = @exif_read_data("$actdir/$imagefile","",true,false);
                        if ( $exifdata==true ) {
                           $org_datetime = $exifdata["EXIF"]["DateTimeOriginal"];
                           $info_d = "";
                           $restore_info_d = "";
                        }
                        if ( $extension=="avi" ) {
                           $subdir = "$setupmovie";
                        }
                        break;
          case "CANON":
                        if ( $extension=="wav" AND substr($file,0,3)=="SND" ) { // annotation soundfile
                           $imagefile = str_replace("WAV","JPG",str_replace("SND","IMG", $file));
                           $exifdata     = @exif_read_data("$actdir/$imagefile","",true,false);
                           if ( $exifdata==true ) {
                              $org_datetime = $exifdata["EXIF"]["DateTimeOriginal"];
                              $info_d = "";
                              $restore_info_d = "";
                           }
                        }  elseif ( $extension=="avi" AND substr($file,0,3)=="MVI" ) { // videofile
                           $imagefile = str_replace("AVI","THM",$file);
                           $exifdata     = @exif_read_data("$actdir/$imagefile","",true,false);
                           if ( $exifdata==true ) {
                              $org_datetime = $exifdata["EXIF"]["DateTimeOriginal"];
                              $info_d = "";
                              $restore_info_d = "";
                           }
                           $subdir = "$setupmovie";
                        }  elseif ( $extension=="thm" AND substr($file,0,3)=="MVI" ) { // video-vorschau-file
                           $neue_endung = ".jpg";
                           $subdir = "$setupmovie";
                        }  elseif ( $extension=="jpg" AND substr($file,0,2)=="ST" ) {  // panoramabilder
                           $subdir = $setuppano;
                        }  elseif ( $extension=="ctg" ) { // hilfsdateien
                           $org_filename = "";
                        }
                        break;
          case "PANASONIC":
                        if ( $extension=="mov" AND substr($file,0,1)=="P" ) { // videofile
                           $imagefile = str_replace("MOV","JPG",$file);
                           $exifdata     = @exif_read_data("$actdir/$imagefile","",true,false);
                           if ( $exifdata==true ) {
                              $org_datetime = $exifdata["EXIF"]["DateTimeOriginal"];
                              $info_d = "";
                              $restore_info_d = "";
                           }
                           $subdir = "$setupmovie";
                        }  elseif ( $extension=="jpg" AND file_exists(str_replace("JPG","MOV","$actdir/$file")) 
						            AND filesize("$actdir/$file")<150000 ) { // video-vorschau-file
                           $neue_endung = ".jpg";
                           $subdir = "$setupmovie";
                        }
                        break;
          case "FUJIFILM":
                        if ( $extension=="wav"  ) { // annotation soundfile
                           $imagefile = str_replace("WAV","JPG",$file);
                           $exifdata     = @exif_read_data("$actdir/$imagefile","",true,false);
                           if ( $exifdata==true ) {
                              $org_datetime = $exifdata["EXIF"]["DateTimeOriginal"];
                              $info_d = "";
                              $restore_info_d = "";
                           }
                        }  elseif ( $extension=="avi" ) { // videofile
                           $info_d = "";
                           $restore_info_d = "";
                           $subdir = "$setupmovie";
                        }  elseif ( $extension=="raf") { // raw
                           $info_d = "";
                           $restore_info_d = "";
                        }
                        break;
          }
       }

       $org_datetime = str_replace(":", "", $org_datetime);
       $org_datetime = str_replace(" ", "_", $org_datetime);

       $year  = substr($org_datetime,0,4);
       $month = substr($org_datetime,4,2);
       $name_to = "$dirtarget/$year/$month";
       if ( $subdir!="" ) {
          $name_to .= "/$subdir";
       }

       if ( $info_d=="" AND substr($org_filename,0,strlen($org_datetime))!=$org_datetime ) {
#      Zeitstempel in den Dateinamen bernehmen und alles kleinschreiben
          $name_to .= "/$org_datetime-$org_filename";
          $name_to = strtolower($name_to);
          if ( $make!="" AND $neue_endung!="" ) {
             $name_to .= $neue_endung;
          }
       }  else {
#      patch: Wenn keine EXIF-Daten vorhanden sind, keinen Zeitstempel in den Namen bernehmen, und auch sonst nicht verndern!
          $name_to .= "/$org_filename";
       }
       $info_d = $restore_info_d;

#      kopieren von einer datei
       echo "\n<tr><td class=\"$tabclass\" valign=\"bottom\">$name_from</td>";
       echo "<td class=\"$tabclass\" valign=\"bottom\">$name_to</td><td class=\"$tabclass\" align=\"right\">$make ($org_filesize MB) ";
       if ( $tabclass=="cbox" ) {
          $tabclass="nbox";
       }  else {
          $tabclass="cbox";
       }

       if ( $make!="" AND $org_filename=="" ) {
          echo "kein copy, Hilfsdatei</td></tr>\n";
          flush();
          continue;
       }

       if ( confirmDirectory("$dirtarget/$year")==1 AND confirmDirectory("$dirtarget/$year/$month")==1 ) {
          if ( $subdir!="" AND confirmDirectory("$dirtarget/$year/$month/$subdir")==1 ) {
          }
          if ( !file_exists($name_to) ) {
             if ( $checkonly==false ) {
                if ( copy($name_from, $name_to) ) {
#                  kopieren via php ndert leider den Zeitstempel, also wieder fixen:
                   touch ( $name_to, filemtime($name_from) );
                   echo "<span class=\"warning\">OK</span>";
                   $uebertragen_mb += $org_filesize;
                   $uebertragen_n++;
                   upload_prot ( "$uebertragen_n.;$name_from;$name_to;" . $org_filesize . " MB;$make"
                   );
                }  else {
                   echo "<span class=\"warning\">FEHLGESCHLAGEN</span>";
                }
             }  else { // checkonly
                echo "<span class=\"warning\">wrde kopiert</span>";
                $uebertragen_mb += $org_filesize;
                $uebertragen_n++;
             }
          }  else {
             echo "existiert bereits";
#            kleiner check ob Dateigre und letzte nderung auch identisch sind
             if ( filesize($name_from)!=filesize($name_to)
                  OR filemtime($name_from)!=filemtime($name_to)  ) {
                  echo "<br /><span class=\"warning\"> => existiert, aber wahrscheinlich nicht identisch (Gre/letzter Zugriff)</span>";
             }
          }
       }
       echo " $info_d ";
       if ( $info_d=="" ) {
#         wir schieben noch das gespeicherte thumbnail so vorhanden hinterher
          if ( $checkonly==false ) {
             $thfile = $name_to;
          }  else {
             $thfile = $name_from;
          }
          echo "<a href=\"$thfile\">";
          echo "<img src=\"".basename($_SERVER['PHP_SELF'])."?thumbnail=$thfile\" title=\"$thfile\" alt=\"thumbnail\" />";
          echo "</a>";
       }
       echo "</td></tr>\n";

       flush();

    } // endif dir or file
 } // endwhile
 closedir($handle);
}



function show_thumbnail($filename) {
# zeigt integriertes thumbnail wenn vorhanden

   $filename = strtolower($filename); // geht nur fuer windows!

   if ( substr($filename,-4)==".avi" ) {
      if ( file_exists(str_replace(".avi", ".thm", $filename)) ) {            // canon original
         $filename = str_replace(".avi", ".thm", $filename);
      }  elseif ( file_exists(str_replace(".avi", ".thm.jpg", $filename)) ) { // canon schon kopiert
         $filename = str_replace(".avi", ".thm.jpg", $filename);
      }
   }

   if ( substr($filename,-4)==".mov" ) {
      if ( file_exists(str_replace(".mov", ".jpg", $filename)) ) {            // panasonic original
         $filename = str_replace(".mov", ".jpg", $filename);
      }  elseif ( file_exists(str_replace(".mov", ".jpg.jpg", $filename)) ) { // panaonic schon kopiert
         $filename = str_replace(".mov", ".jpg.jpg", $filename);
      }
   }

   if ( substr($filename,-4)==".wav" ) {
      if ( file_exists(str_replace("snd","img",str_replace(".wav", ".jpg", $filename))) ) { // canon fuji
         $filename = str_replace("snd","img",str_replace(".wav", ".jpg", $filename));
      }
   }


   $image = @exif_thumbnail($filename, $width, $height, $type);

   if ($image!==false) {
       header('Content-type: ' .image_type_to_mime_type($type));
       echo $image;
       exit;
   }  else {
      if ( filesize($filename)<101000 AND (strtolower(substr($filename,-4))==".thm" OR substr($filename,-8)==".thm.jpg") ) {
         header("Content-Type: image/jpg");
         readfile($filename);
      }  else {
         $Jpeg = ImageCreate(160,16);
         $bg = ImageColorAllocate($Jpeg,255,150,0);
         $tx = ImageColorAllocate($Jpeg,250,250,250);
         ImageFilledRectangle($Jpeg,0,0,3,3,$bg);
         ImageString($Jpeg,2,1,1, " Kein Thumbnail vorhanden! " ,$tx);
         header("Content-Type: image/png");
         ImageJpeg($Jpeg, "", 100);
         ImageDestroy($Jpeg);
      }
   }
}




function upload_prot( $note ) {
# schreibt Protokollfile weiter
 global $setupdirtarget, $protfile, $protswitch;


// Append Satz an Datei
 $dh = fopen( "$setupdirtarget/$protfile", "ab" );

 if ( $protswitch==false ) {
    $protswitch = true;
    fputs($dh,
       date("Y.m.d H:i D")
       . " ============================================================================================================"
       . "\r\n");

 }

 fputs($dh,
       date("Y.m.d H:i D")
       . ";" . $note
       . "\r\n");
 fclose($dh);

} // end function upload_prot





function html_header() {
# schreibt den Standard-HTML-Kram raus und stellt CSS zur Verfgung...
?><!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<meta name="GENERATOR" content="http://galupki.de fotodownloader">
<meta name="robots" content="noindex,nofollow,noarchive">
<meta name="Author" content="Juergen Galupki">
<title>
foto downloader 1.1 beta (work in progress)
</title>
<base target="_top">

<style type="text/css">
body, table {
       background-color: #FFFFFF;
       color:            #000000;
       font-size:        90%;
       font-family:      Tahoma, Verdana, Helvetica, sans-serif;
}

a {
       font-weight: bold;
}

a:link  {
       text-decoration : none;
       margin-bottom: 1px;
       padding: 1px;
       border: 1px;
       color : #FF0000;
}

a:visited  {
       text-decoration : none;
       margin-bottom: 1px;
       padding: 1px;
       border: 1px;
       color : #FF0000;
}

a:hover {
       text-decoration : none;
       margin-bottom: 1px;
       padding: 1px;
       border-bottom: 1px dashed;
       color: #8000FF;
       background-color: #EBEBEB;
}

a:active {
       text-decoration : none;
       margin-bottom: 1px;
       padding: 1px;
       border: 1px;
       color: #FF0000;
}

h1 { font-size: 200%;
     color:            #000000;
     background-color: #EBEBEB;
   }
h2 { font-size: 175%;
     color:            #000000;
     background-color: #EBEBEB;
   }
h3 { font-size: 150%; }
h4 { font-size: 125%; }

strong {
        color: #4F4F4F;
        font-weight: bold;
}

form, table  { color:            #000000;
        background-color: #EBEBEB;
}

sup {  font-size: 75%}
sub {  font-size: 75%}


/* * * * * *  classes * * * * * */

.nbox { color:            #000000;
        background-color: #EBEBEB;
}
.cbox { color:            #000000;
        background-color: #FFFFFF;
}

.large    { font-size: 125%; font-weight: bold; }
.normal   { font-size: 100%; font-weight: bold; }
.small    { font-size: 85%; }
.footnote { font-size: 85%;
            color:            #000000;
            background-color: #EBEBEB; }
.warning  { color:            #FF0000;   }
.ack      { color:            #00FF00;   }


img {
 border: 0px;
	max-height: 200px;
	max-width: 200px;
}

</style>
</head>
<body>
<?php
}
?>